// $G $F.go && $L $F.$A && ./$A.out

// Copyright 2010 The Go Authors. All rights reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

package main

import (
	"fmt"
	"math"
)

func main() {
	var a float64 = math.MaxFloat64
	check("a := MaxFloat64; a*a/a", a*a/a, math.Inf(1))
	a = math.SmallestNonzeroFloat64
	check("a := SmallestNonzeroFloat64; a*a/a", a*a/a, 0)
	var b float32 = math.MaxFloat32
	check("b := MaxFloat32; b*b/b", float64(b*b/b), math.Inf(1))
	b = math.SmallestNonzeroFloat32
	check("b := SmallestNonzeroFloat32; b*b/b", float64(b*b/b), 0)
	var h, i float64 = 1.3333333333333333, 1e+308
	check("1.3333333333333333/1e+308", h/i, 1.333333333333333e-308)
	h = 3.3376107877608026e-308
	i = 4.503599627370497e+15
	check("3.3376107877608026e-308/4.503599627370497e+15", h/i, 5e-324)
}

var bad = false

func check(name string, a, b float64) {
	if a == b {
		return
	}
	if !bad {
		bad = true
		fmt.Println("BUG: float")
	}
	fmt.Printf("%s = %g, want %g\n", name, a, b)
}
